Summary:	The GNU core utilities: a set of tools commonly used in shell scripts
Name:		coreutils
Group:		System Environment/Base
License:	GPL
Version:	5.2.1
Release:	3
Source0:	ftp://ftp.gnu.org/pub/gnu/%{name}/%{name}-%{version}.tar.bz2
Source100:	DIR_COLORS
Source101:	colorls.sh
Source102:	colorls.csh
Source103:	su.pamd-gd-3

# Patches taken from Red Hat Fedora Core 4
Patch100:	fileutils-4.1.10-timestyle.patch
Patch101:	fileutils-4.1.5-afs.patch
Patch102:	fileutils-4.1-dircolors_c.patch
Patch103:	fileutils-4.1.10-utmp.patch
Patch104:	coreutils-acl.patch
Patch105:	sh-utils-2.0.11-dateman.patch
Patch106:	sh-utils-1.16-paths.patch
Patch107:	coreutils-pam.patch
Patch108:	coreutils-4.5.3-langinfo.patch
Patch109:	coreutils-4.5.3-printf-ll.patch
Patch110:	coreutils-4.5.3-sysinfo.patch
Patch111:	coreutils-i18n.patch
Patch112:	coreutils-5.0-allow_old_options.patch
Patch113:	coreutils-jday.patch
Patch114:	coreutils-fchown.patch
Patch115:	coreutils-5.2.1-runuser.patch
Patch116:	coreutils-getgrouplist.patch
Patch117:	coreutils-zh_CN.patch
Patch118:	coreutils-gcc4.patch
Patch119:	coreutils-brokentest.patch
Patch120:	coreutils-overflow.patch
Patch121:	coreutils-dateseconds.patch
Patch122:	coreutils-chown.patch
Patch123:	coreutils-rmaccess.patch
Patch124:	coreutils-copy.patch
Patch125:	coreutils-stale-utmp.patch
Patch126:	coreutils-selinux.patch

BuildRoot:	%{_tmppath}/%{name}-%{release}-root
BuildRequires:	gettext libtermcap-devel pam-devel
BuildRequires:	texinfo >= 4.3
Requires:	pam >= 0.66-12
Prereq:		grep, findutils
Provides:	fileutils = %version, sh-utils = %version, stat, textutils = %version
Obsoletes:	fileutils sh-utils stat textutils

%description
These are the GNU core utilities.  This package is the combination of
the old GNU fileutils, sh-utils, and textutils packages.

%files -f %{name}.lang
  %defattr(-,root,root)
  %doc ABOUT-NLS NEWS README THANKS TODO old/*
  %doc %{_mandir}/man?/*
  %doc %{_infodir}/coreutils*

  %config(noreplace) %{_sysconfdir}/DIR_COLORS*
  %config(noreplace) %{_sysconfdir}/profile.d/*
  %attr(0644,root,root)	%config(noreplace) %{_sysconfdir}/pam.d/su

  %exclude %{_bindir}/su
  %attr(0511,root,root)		%{_root_bindir}/*
  %attr(0511,root,root)		%{_bindir}/*
  %attr(0511,root,root)		%{_sbindir}/chroot

  # These get special permissions.
  %attr(0510,root,admin)	%{_root_bindir}/nice
  %attr(4510,root,admin)	%{_root_bindir}/su
  %attr(0510,root,admin)	%{_root_sbindir}/runuser
  %attr(0510,root,admin)	%{_sbindir}/chroot

%prep
%setup -q
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%patch121 -p1
%patch122 -p1
%patch123 -p1
%patch124 -p1
%patch125 -p1
%patch126 -p1

  perl -pi -e 's/basic-1//g' tests/stty/Makefile*
  chmod a+x tests/sort/sort-mb-tests

%build
  export CFLAGS="$RPM_OPT_FLAGS -fpic"
  %{expand:%%global optflags %{optflags} -D_GNU_SOURCE=1}

  touch aclocal.m4 configure config.hin Makefile.in */Makefile.in */*/Makefile.in
  aclocal -I m4
  autoconf --force
  automake --copy --force

  %configure --enable-largefile --enable-pam --enable-selinux
  make all %{?_smp_mflags} CPPFLAGS="-DUSE_PAM" su_LDFLAGS="-pie -lpam -lpam_misc"

  unset LINGUAS || :

# # Run the test suite.
# make check || :

  # XXX docs should say /var/run/[uw]tmp not /etc/[uw]tmp
  perl -pi -e 's,/etc/utmp,/var/run/utmp,g;s,/etc/wtmp,/var/run/wtmp,g' doc/coreutils.texi

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  %makeinstall

  # man pages are not installed with make install
  make mandir=$RPM_BUILD_ROOT%{_mandir} install-man

  # fix japanese catalog file
  if [ -d $RPM_BUILD_ROOT/%{_datadir}/locale/ja_JP.EUC/LC_MESSAGES ]; then
     mkdir -p $RPM_BUILD_ROOT/%{_datadir}/locale/ja/LC_MESSAGES
     mv $RPM_BUILD_ROOT/%{_datadir}/locale/ja_JP.EUC/LC_MESSAGES/*mo \
		$RPM_BUILD_ROOT/%{_datadir}/locale/ja/LC_MESSAGES
     rm -rf $RPM_BUILD_ROOT/%{_datadir}/locale/ja_JP.EUC
  fi

  # let be compatible with old fileutils, sh-utils and textutils packages
  mkdir -p $RPM_BUILD_ROOT/%{_bindir}
  mkdir -p $RPM_BUILD_ROOT/%{_root_bindir}
  mkdir -p $RPM_BUILD_ROOT/%{_root_sbindir}
  mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d

  for f in basename cat chgrp chmod chown cp cut date dd df echo env false \
           link ln ls mkdir mknod mv nice pwd rm rmdir sleep sort stty sync \
           touch true uname unlink
  do
	mv $RPM_BUILD_ROOT/{%{_bindir},%{_root_bindir}}/$f
  done

  # chroot was in /usr/sbin :
  mv $RPM_BUILD_ROOT/{%{_bindir},%{_sbindir}}/chroot

  # {cat,sort,cut} were previously moved from bin to /usr/bin and linked into 
  for i in env cut
  do
    ln -sf ../../bin/$i $RPM_BUILD_ROOT/%{_bindir}
  done

  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/profile.d
  install -c -m644 %{SOURCE100} $RPM_BUILD_ROOT/%{_sysconfdir}/
  install -c -m755 %{SOURCE101} $RPM_BUILD_ROOT/%{_sysconfdir}/profile.d
  install -c -m755 %{SOURCE102} $RPM_BUILD_ROOT/%{_sysconfdir}/profile.d

  # su
  install src/su       $RPM_BUILD_ROOT/%{_root_bindir}
  install src/runuser  $RPM_BUILD_ROOT/%{_root_sbindir}
  install %{SOURCE103} $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/su

  # These come from util-linux and/or procps.
  for i in hostname uptime ; do
    rm -f $RPM_BUILD_ROOT/%{_bindir}/$i
    rm -f $RPM_BUILD_ROOT/%{_mandir}/man1/$i.1
  done

  ln -sf test $RPM_BUILD_ROOT%_bindir/[

  bzip2 -f9 old/*/C* || :

  # Remove unpackaged files
  rm -f $RPM_BUILD_ROOT/%{_datadir}/info/dir
  rm -f $RPM_BUILD_ROOT/%{_bindir}/kill
  rm -f $RPM_BUILD_ROOT/%{_mandir}/man1/kill.1*

  %find_lang %{name}
  cat %{name}.lang | sed -e 's/LC_MESSAGES/LC_TIME/g' > %{name}2.lang
  cat %{name}2.lang >> %{name}.lang

%pre
  # Remove these old glibc files on upgrade (RH bug #84090).
  for file in $(find /usr/share/locale -type f -name LC_TIME); do
	[ -x /bin/rm ] && /bin/rm -f "$file"
  done

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Sep 15 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.2.1, Release 3
  - Use pam_selinux in the 'su' pam.d file, fixes #0000856.

* Wed Jul 06 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.2.1, Release 2
  - Package /sbin/runuser.

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.2.1, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
